const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const sprint_items = sequelize.define(
    'sprint_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

state: {
        type: DataTypes.ENUM,
      
      

        values: [

"committed",


"added",


"removed"

        ],

      },

story_points: {
        type: DataTypes.DECIMAL,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  sprint_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity































//end loop



    db.sprint_items.belongsTo(db.sprints, {
      as: 'sprint',
      foreignKey: {
        name: 'sprintId',
      },
      constraints: false,
    });

    db.sprint_items.belongsTo(db.user_stories, {
      as: 'story',
      foreignKey: {
        name: 'storyId',
      },
      constraints: false,
    });

    db.sprint_items.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.sprint_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.sprint_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return sprint_items;
};


